#ifndef LNM_HTTP_ROUTER_INTERNAL
#define LNM_HTTP_ROUTER_INTERNAL

#include "lnm/common.h"

typedef struct lnm_http_route {
} lnm_http_route;

typedef struct lnm_http_router {
  struct lnm_http_router *exact_children[128];
  struct lnm_http_router *single_segment_child;
  lnm_http_route *route;
} lnm_http_router;

/**
 * Allocate and initialize a new http_router.
 */
lnm_err lnm_http_router_init(lnm_http_router **out);

void lnm_http_router_free(lnm_http_router *router);

lnm_err lnm_http_route_init(lnm_http_route **out);

void lnm_http_route_free(lnm_http_route *route);

lnm_err lnm_http_router_add(lnm_http_route **out, lnm_http_router *http_router,
                            const char *path);

/**
 * Add all of the child router's routes to the parent router, under the given
 * route prefix.
 */
lnm_err lnm_http_router_nest(lnm_http_router *parent,
                             const lnm_http_router *child, const char *prefix);

#endif
